@echo off
REM @copyright(external)
REM 
REM IBM Confidential
REM OCO Source Materials
REM 5724-V36
REM (c) Copyright IBM Corp. 2008, 2014
REM 
REM The source code for this program is not published or otherwise
REM divested of its trade secrets, irrespective of what has
REM been deposited with the U.S. Copyright Office.
REM 
REM DISCLAIMER OF WARRANTIES. The following [enclosed] script is created by IBM
REM Corporation. IBM grants you a nonexclusive copyright license to use this
REM script. This script is provided to you solely for the purpose of assisting
REM you in your applications. IBM cannot guarantee nor may you imply reliability,
REM serviceability, or function of these programs. The script is provided "AS IS",
REM without warranty of any kind. IBM shall not be liable for any damages arising
REM out of your or any other parties' use of the script, even if IBM has been advised
REM of the possibility of such damages. If you do not agree with these terms, do not
REM use the script.
REM 
REM @endCopyright

setlocal

set COMMAND=%1
set DEBUG=%2
set ICM_CLIENT=%~s3
set WAS_HOME=%~s4
set JAVA_HOME=%~s5

IF EXIST "%WAS_HOME%\java\8.0\jre" (
echo %WAS_HOME%\java\8.0\jre exists. 
SET JRE_HOME=%WAS_HOME%\java\8.0\jre
) ELSE (
SET JRE_HOME=%WAS_HOME%\java\jre
)
SET JAVA_HOME=%JRE_HOME%

set TEMP_DIR=%~s6
set DBNAME=%7
set USERID=%8
set PW=%9
REM Batch limitation, need to SHIFT for all params over 9
SHIFT
set SCHEMA=%9
SHIFT
set EDISC_GROUP_NAME=%9


echo COMMAND=%COMMAND%
echo DEBUG=%DEBUG%
echo ICM_CLIENT=%ICM_CLIENT%
echo WAS_HOME=%WAS_HOME%
echo JAVA_HOME=%JAVA_HOME%
echo TEMP_DIR=%TEMP_DIR%
echo DBNAME=%DBNAME%
echo CMUSERID=%USERID%
echo SCHEMA=%SCHEMA%
echo EDISC_GROUP_NAME=%EDISC_GROUP_NAME%

 
REM @call "%ICM_CLIENT%\bin\cmbenv81.bat"

set ICMLIB=%ICM_CLIENT%\lib
set EDMCP=%TEMP_DIR%\ICM;%TEMP_DIR%\ICM\config;%TEMP_DIR%;%TEMP_DIR%\rs.jar;%TEMP_DIR%\edcral.jar;%TEMP_DIR%\edcutil.jar;%TEMP_DIR%\edclog.jar;%TEMP_DIR%\rs-cm.jar;%TEMP_DIR%\edcral-cm.jar;%TEMP_DIR%\rs-p8.jar;%TEMP_DIR%\icu4j-58_2.jar;%TEMP_DIR%\icu4j-charset-58_2.jar;
set ICMCP=%ICM_CLIENT%\cmgmt;%ICMLIB%\jcache.jar;%ICMLIB%\db2jcc_license_cu.jar;%ICMLIB%\db2jcc.jar;%ICMLIB%\db2jcc4.jar;%ICMLIB%\cmblog4j81.jar;%ICMLIB%\log4j-1.2.15.jar;%ICMLIB%\log4j-1.2.8.jar;%ICMLIB%\cmbutil81.jar;%ICMLIB%\cmbsdk81.jar;%ICMLIB%\cmbicmsdk81.jar
set EDMICMCP=%EDMCP%;%ICMCP%
echo EDM_ICM_CLASSPATH=%EDMICMCP%


if not %COMMAND% == CREATE (
 goto continue
 )
 
echo Start creation of roles, privileges, privilege sets, groups
REM All the connection information resides in ral.properties.
set MAINCLASS=com.ibm.icm.edc.ral.bootstrap.impl.RolesUtil
echo Running class: %MAINCLASS%
echo run: %JAVA_HOME%\bin\java -Dediscovery.encryption.key.location=%TEMP_DIR%\eDiscoveryKey.txt -Dedm_debug=%DEBUG% -classpath %EDMICMCP% %MAINCLASS% CREATE_ROLES
%JAVA_HOME%\bin\java -Dediscovery.encryption.key.location=%TEMP_DIR%\eDiscoveryKey.txt -Dedm_debug=%DEBUG% -classpath %EDMICMCP% %MAINCLASS% CREATE_ROLES
set rc=%errorlevel%
if not %rc% == 0 (
 goto done
)

echo Start create data model.
REM During install the data model is created (using CREATE command).
REM All the connection information is passed on the command line for DataModelICM, ral.properties is not used.
set MAINCLASS=com.ibm.icm.edc.ral.bootstrap.cm.impl.DataModelCM
echo Command is:%COMMAND%
echo Class:%MAINCLASS%
%JAVA_HOME%\bin\java -Dediscovery.encryption.key.location=%TEMP_DIR%\eDiscoveryKey.txt -Dedm_debug=%DEBUG% -classpath %EDMICMCP% %MAINCLASS% CREATE %DBNAME% %USERID% %PW% %SCHEMA%
set rc=%errorlevel%
goto done

:continue
if not %COMMAND% == CONNECT (
 goto delete
 ) 
REM All the connection information is passed on the command line for DataModelICM, ral.properties is not used.
set MAINCLASS=com.ibm.icm.edc.ral.bootstrap.cm.impl.DataModelCM
echo Command is:%COMMAND%
echo Running:%MAINCLASS%
%JAVA_HOME%\bin\java  -Dediscovery.encryption.key.location=%TEMP_DIR%\eDiscoveryKey.txt -Dedm_debug=%DEBUG% -classpath %EDMICMCP% %MAINCLASS% %COMMAND% %DBNAME% %USERID% %PW% %SCHEMA%
set rc=%errorlevel%
goto done
 

:delete
REM All the connection information resides in ral.properties. The group to be deleted is retrieved from the 
REM config data in the repository. The file ral.properties used by this script was created in the installer before
REM this script is called, and it resides in edmhome\lib which is the $TEMP_DIR directory during uninstall.

echo Start delete group ( the group to be deleted is retrieved from the config data in the repository).
set MAINCLASS=com.ibm.icm.edc.ral.bootstrap.impl.RolesUtil
echo Running: %MAINCLASS%
%JAVA_HOME%\bin\java -Dediscovery.encryption.key.location=%TEMP_DIR%\eDiscoveryKey.txt -Dedm_debug=%DEBUG% -classpath %EDMICMCP% %MAINCLASS% DELETE_GROUP_GET_GROUP_NAME_FROM_CONFIG 
set rc=%errorlevel%
REM Give warning if unable to delete group and continue
if not %rc% == 0 (
 echo Warning: An error occurred while deleting the eDiscovery users group. Use IBM CM SysAdmin to delete the group.
)

echo Start delete data model
set MAINCLASS=com.ibm.icm.edc.ral.bootstrap.cm.impl.DataModelCM
echo Command is:%COMMAND%
echo Running:%MAINCLASS%
%JAVA_HOME%\bin\java -Dediscovery.encryption.key.location=%TEMP_DIR%\eDiscoveryKey.txt -Dedm_debug=%DEBUG% -classpath %EDMICMCP% %MAINCLASS% DELETEALL %DBNAME% %USERID% %PW% %SCHEMA% %EDISC_GROUP_NAME%

set rc=%errorlevel%
if not %rc% == 0 (
 goto done
)

echo Start delete of roles ( EDM* groups, privs, priv sets)
set MAINCLASS=com.ibm.icm.edc.ral.bootstrap.impl.RolesUtil
echo Running: %MAINCLASS%
%JAVA_HOME%\bin\java  -Dediscovery.encryption.key.location=%TEMP_DIR%\eDiscoveryKey.txt -Dedm_debug=%DEBUG% -classpath %EDMICMCP% %MAINCLASS% DELETE_ROLES 
set rc=%errorlevel%
goto done


:done
@echo Command:%COMMAND% 
@echo Return code:%rc%
endlocal
exit %rc%

